routes/web.php
<?php

use App\Http\Controllers\FeedController;
use App\Http\Controllers\MainController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

/** Admin Panel */
Route::prefix('')->name('panel.')->group(function($router) {
    $router->get('', [MainController::class, 'index'])->name('feeds.index');
    $router->get('get-updates', [MainController::class, 'getUpdates'])->name('feeds.get.updates');

    $router->get('requests', [MainController::class, 'requests'])->name('requests.index');

});

app/Models/News.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class News extends Model
{
    use HasFactory;

    protected $guarded = [];

}

app/Models/Request.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Request extends Model
{
    use HasFactory;

    protected $guarded = [];
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/MainController.php
<?php

namespace App\Http\Controllers;

use App\Models\News;
use App\Models\Request;
use Illuminate\Support\Carbon;
use Vedmant\FeedReader\Facades\FeedReader;

class MainController extends Controller
{
    public function index(){
        $items = News::orderBy('published_date', 'desc')
            ->paginate(12);

        return view('admin.pages.feed.index', compact('items'));
    }

    public function getUpdates(){
        $url = 'http://static.feed.rbc.ru/rbc/logical/footer/news.rss';
        $f = FeedReader::read($url);

        foreach ($f->get_items() as $item ){
            if(!News::where('link', $item->get_link())->first()) {
                $feed = [
                    'title' => $item->get_title(),
                    'link' => $item->get_link(),
                    'short_description' => $item->get_content(),
                    'published_date' => Carbon::parse($item->get_date())->format('d-m-Y H:i:s'),
                    'author' => $item->get_author() ? $item->get_author()->email : '',
                    'image' => $item->get_enclosures()[0]->link ? $item->get_enclosures()[0]->link : ''
                ];

                News::create($feed);
            }
        }

        Request::create([
            'method' => 'GET',
            'url' => $url,
            'response_code' => 200,
            'response_body' => $f,
        ]);

        return redirect()->back()->with('success', "News successfully updated");
    }

    public function requests(){
        $items = Request::orderBy('created_at', 'desc')
            ->paginate(12);

        return view('admin.pages.request.index', compact('items'));
    }
}

resources/views/admin/layouts/index.blade.php
{{--<!DOCTYPE html>--}}
{{--<html lang="ru">--}}
{{--<head>--}}
{{--    @include('admin.layouts.partials.head')--}}
{{--</head>--}}
{{--<body>--}}
{{--<input id="lang" type="hidden" value="ru">--}}
{{--    <div class="main-wrapper">--}}
{{--    @include('admin.layouts.partials.sidebar')--}}

{{--        <main class="main">--}}

{{--            @yield('content')--}}

{{--        </main>--}}

{{--        @include('admin.layouts.partials.footer')--}}
{{--    </div>--}}

{{--    @include('admin.layouts.partials.scripts')--}}

{{--    @yield('scripts')--}}

{{--</body>--}}
{{--</html>--}}



<!DOCTYPE html>
<html lang="en">
<head>
    @include('admin.layouts.partials.head')
</head>
<body>

<input id="lang" type="hidden" value="ru">
<div class="main-wrapper">
    @include('admin.layouts.partials.sidebar')

    <div class="right-wrapper">
        @include('admin.layouts.partials.header')

        <main class="main">

            @yield('content')

        </main>

        @include('admin.layouts.partials.footer')

    </div>
</div>

@include('admin.layouts.partials.scripts')

@yield('scripts')

</body>
</html>

resources/views/admin/layouts/partials/footer.blade.php
<footer class="footer">
</footer>

resources/views/admin/layouts/partials/head.blade.php
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width">
<title>@yield('title','') - Admin Panel Template</title>

<link rel="stylesheet" href="/admin/libs/fancybox/dist/jquery.fancybox.min.css" type="text/css" media="screen"/>
<link rel="stylesheet" href="/admin/libs/chosen/chosen.css" type="text/css" media="screen"/>
<link rel="stylesheet" href="/admin/libs/air-datepicker/dist/css/datepicker.css" type="text/css" media="screen"/>
<link rel="stylesheet" href="/admin/css/style.css" type="text/css" media="screen"/>

<link rel="apple-touch-icon" sizes="180x180" href="/admin/favicon/apple-touch-icon.png">
<link rel="icon" type="image/png" sizes="32x32" href="/admin/favicon/favicon-32x32.png">
<link rel="icon" type="image/png" sizes="16x16" href="/admin/favicon/favicon-16x16.png">
<link rel="manifest" href="/admin/favicon/site.webmanifest">
<link rel="mask-icon" href="/admin/favicon/safari-pinned-tab.svg" color="#5bbad5">
<meta name="msapplication-TileColor" content="#da532c">
<meta name="theme-color" content="#ffffff">

<meta name="title" content="Заголовок">
<meta name="description" content="Описание">
<meta name="keywords" content="">
<meta property="og:type" content="article">
<meta property="og:title" content="Заголовок">
<meta property="og:description" content="Описание">
<meta property="og:url" content="/">
<meta property="og:image" content="/admin/img/og-image.jpg">
<meta property="og:site_name" content="localhost:9876">
<meta property="twitter:card" content="summary_large_image">
<meta property="twitter:title" content="Заголовок">
<meta property="twitter:description" content="Описание">
<meta property="twitter:image" content="/admin/img/og-image.jpg">
<meta property="twitter:site" content="">
<meta property="twitter:creator" content="">
<meta property="twitter:url" content="/">
<meta property="author" content="">
<meta name="relap-image" content="/admin/img/og-image.jpg">
<meta name="relap-title" content="Заголовок">
<meta name="relap-description" content=" ">

resources/views/admin/layouts/partials/header.blade.php
<header class="header">
    <div class="container container-fluid">
        <a href="javascript:;" title="Свернуть/развернуть навигацию" class="menu-btn icon-menu"></a>
        <a href="/" title="Главная" class="logo hidden-md hidden-lg"><img src="/admin/img/logo-blue.svg" alt=""></a>
        <div class="language hidden-sm hidden-xs">
{{--            <a href="#" title="РУС" class="active">РУС</a>--}}
{{--            <a href="#" title="ENG">ENG</a>--}}
        </div>
        <div class="header-dropdown account-nav">
{{--            <div class="header-dropdown__title">--}}
{{--                <span>Добро пожаловать, Илья!</span> <img src="/admin/img/user.svg" alt=""> <i--}}
{{--                    class="icon-chevron-down"></i>--}}
{{--            </div>--}}
{{--            <div class="header-dropdown__desc">--}}
{{--                <ul>--}}
{{--                    <li class="language hidden-md hidden-lg"><a href="#" title="РУС" class="active">РУС</a><a href="#" title="ENG">ENG</a></li>--}}
{{--                    <li><a href="#" title="Выйти">Выйти</a></li>--}}
{{--                </ul>--}}
{{--            </div>--}}
        </div>
    </div>
</header>

resources/views/admin/layouts/partials/modals.blade.php
<div id="message" class="modal" style="display: none;">
    <h4 class="title-secondary">Удаление</h4>
    <div class="plain-text">
        При удалении все данные будут удалены
    </div>
    <hr>
    <div class="buttons justify-end">
        <div><button class="btn btn--red">Удалить</button></div>
        <div><button class="btn" data-fancybox-close>Отмена</button></div>
    </div>
</div>

resources/views/admin/layouts/partials/scripts.blade.php
<script src="/admin/libs/jquery/dist/jquery.js"></script>
<script src="/admin/libs/maskedinput/maskedinput.js"></script>
<script src="/admin/libs/fancybox/dist/jquery.fancybox.min.js"></script>
<script src="/admin/libs/chosen/chosen.jquery.js"></script>
<script src="/admin/libs/air-datepicker/dist/js/datepicker.js"></script>
<script type="text/javascript" src="/admin/libs/plupload/js/plupload.full.min.js"></script>
<script src="/admin/js/scripts.js"></script>

resources/views/admin/layouts/partials/sidebar.blade.php
<aside class="sidebar">
    <div class="sidebar__top hidden-sm hidden-xs">
        <a href="/" title="Главная" class="logo"><img src="/admin/img/logo.svg" alt=""></a>
    </div>
    <div class="menu-wrapper">
        <ul class="menu">
            <li class="dropdown">
                <a href="javascript:;" title="Роли"><i class="icon-users"></i>Новости</a>
                <ul>
                    <li><a class="nav-link" href="{{ route('panel.feeds.index') }}">Список новостей</a></li>
                </ul>
            </li>
            <li class="dropdown">
                <a href="javascript:;" title="Роли"><i class="icon-users"></i>Запросы</a>
                <ul>
                    <li><a class="nav-link" href="{{ route('panel.requests.index') }}">Список запросов</a></li>
                </ul>
            </li>
        </ul>
    </div>
</aside>

resources/views/admin/pages/feed/index.blade.php
@extends('admin.layouts.index')

@section('title', "Feeds")

@section('content')

<div class="container container-fluid">
    <div class="title-block">
        <div class="row row--multiline align-items-center">
            <div class="col-md-4">
                <h1 class="title-primary" style="margin-bottom: 0">Управление новостями</h1>
            </div>
            <div class="col-md-8 text-right-md text-right-lg">
                <div class="flex-form">
                    <div>
                        <a href="{{ route('panel.feeds.get.updates') }}" class="btn btn-primary">Get updates</a>
                    </div>
                </div>
            </div>
        </div>
    </div>

    @if ($message = Session::get('success'))
        <div class="alert alert-success">
            <p>{{ $message }}</p>
        </div>
    @endif

    <div class="block">
        <div class="title-block">
            <div class="row row--multiline align-items-center">
                <div class="col-md-4">
                    <h2 class="title-secondary">Список новостей</h2>
                </div>
                <div class="col-md-8 text-right-md text-right-lg">
                    <div class="flex-form">
                        <div>
                            <h2 class="title-secondary">Всего - {{ $items->total() }}</h2>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <table class="table table-records">
            <colgroup>
                <col span="1" style="width: 3%;">
                <col span="1" style="width: 15%;">
                <col span="1" style="width: 40%;">
                <col span="1" style="width: 10%;">
                <col span="1" style="width: 15%;">
                <col span="1" style="width: 10%;">
                <col span="1" style="width: 10%;">
            </colgroup>
            <thead>
                <tr>
                    <th>No</th>
                    <th>Название</th>
                    <th>Краткое описание</th>
                    <th>Дата публикации</th>
                    <th>Автор</th>
                    <th>Ссылка</th>
                    <th>Изображение</th>
                </tr>
            </thead>
            <tbody>
                @foreach ($items as $item)
                    <tr>
                        <td>{{ $item->id }}</td>
                        <td><a href="{{ $item->link }}" target="_blank">{{ $item->title }}</a>/</td>
                        <td>{{ $item->short_description }}</td>
                        <td>{{ $item->published_date }}</td>
                        <td>{{ $item->author }}</td>
                        <td><a href="{{ $item->link }}" target="_blank">{{ $item->link }}</a></td>
                        <td><a href="{{ $item->image ?? '#'}}" target="_blank">{{ $item->image  ?? '-'}}</a></td>
                    </tr>
                @endforeach
            </tbody>
        </table>

        {{ $items->appends(\Illuminate\Support\Facades\Request::except('page'))->links("vendor.pagination.admin") }}
    </div>
</div>

@endsection
@section('scripts')
    <!--Only this page's scripts-->
    <!---->
@endsection

resources/views/admin/pages/request/index.blade.php
@extends('admin.layouts.index')

@section('title', "Feeds")

@section('content')

<div class="container container-fluid">
    <div class="title-block">
        <div class="row row--multiline align-items-center">
            <div class="col-md-4">
                <h1 class="title-primary" style="margin-bottom: 0">Управление запросами</h1>
            </div>
            <div class="col-md-8 text-right-md text-right-lg">
                <div class="flex-form">
                    <div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="block">
        <div class="title-block">
            <div class="row row--multiline align-items-center">
                <div class="col-md-4">
                    <h2 class="title-secondary">Список запросов</h2>
                </div>
                <div class="col-md-8 text-right-md text-right-lg">
                    <div class="flex-form">
                        <div>
                            <h2 class="title-secondary">Всего - {{ $items->total() }}</h2>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <table class="table table-records">
            <colgroup>
                <col span="1" style="width: 3%;">
                <col span="1" style="width: 15%;">
                <col span="1" style="width: 10%;">
                <col span="1" style="width: 15%;">
                <col span="1" style="width: 15%;">
                <col span="1" style="width: 40%;">
            </colgroup>
            <thead>
                <tr>
                    <th>No</th>
                    <th>Дата и время</th>
                    <th>Request Method</th>
                    <th>Request URL</th>
                    <th>Response HTTP Code</th>
                    <th>Response Body</th>
                </tr>
            </thead>
            <tbody>
                @foreach ($items as $item)
                    <tr>
                        <td>{{ $item->id }}</td>
                        <td>{{ $item->created_at }}</td>
                        <td>{{ $item->method }}</td>
                        <td>{{ $item->url }}</td>
                        <td>{{ $item->response_code }}</td>
                        <td>{{ $item->response_body }}</td>
                    </tr>
                @endforeach
            </tbody>
        </table>

        {{ $items->appends(\Illuminate\Support\Facades\Request::except('page'))->links("vendor.pagination.admin") }}
    </div>
</div>

@endsection
@section('scripts')
    <!--Only this page's scripts-->
    <!---->
@endsection

resources/views/feed.blade.php
{{--@extends('app')--}}

{{--@section('content')--}}
    <div class="header">
        <h1><a href="{{ $permalink }}">{{ $title }}</a></h1>
    </div>

    @foreach ($items as $item)
        <div class="item">
            <h2><a href="{{ $item->get_permalink() }}">{{ $item->get_title() }}</a></h2>
            <p>{{ $item->get_description() }}</p>
            <p><small>Posted on {{ $item->get_date('j F Y | g:i a') }}</small></p>
        </div>
    @endforeach
{{--@endsection--}}